阅读 30

Python学习笔记(七) 异常处理

这篇文章将会介绍 Python 中异常及其处理方法


1、基本概念

异常是一种非正常状态,它表示程序在执行过程中发生错误

在实际情况中,可能会有多种原因导致程序出现异常状态,而每种异常状态都会由一个异常对象表示

当程序出现异常状态时,会抛出一个异常对象,如果该对象未被捕获和处理,程序将会中止

在一般情况下,程序员需要考虑各种可能的异常原因,手动捕获并处理异常,以避免程序突然中止

2、异常类型

导致程序出现异常的原因有很多,以下列举一些系统内置的常见的异常对象

异常对象描述
Exception几乎所有异常类的基类
SyntaxError语法错误
TypeError将内置函数用于类型不正确的对象
ValueError将内置函数用于类型正确但包含值不正确的对象
AttributeError引用属性错误
NameError引用变量错误
IndexError使用序列中不存在的索引
KeyError使用映射中不存在的键值

除系统内置的异常对象外,用户还可以自定义异常对象,自定义的异常对象需要继承一个异常类

class MyException(Exception):
    def __init__(self, info):
        super().__init__(self)
        self.info = info
    def __str__(self):
        return self.info

try:
    raise MyException('my exception')
except MyException as e:
    print(e)

# my exception
复制代码

3、异常抛出

当语句执行发生错误时,该语句会抛出一个异常

num = 1 / 0
复制代码

除了被动抛出的异常外,我们还能使用 raise 语句主动抛出一个异常

raise Exception('Error')
复制代码

4、异常处理

我们可以用 try-except 捕获和处理异常,若在 try 中出现异常,则马上执行 except 中的代码

try:
    print('begin')
    string = 'hello'
    number = int(string)
    print('end')
except:
    print('exception')

# begin
# exception
复制代码

我们也能在 try-except 后加上 else,在没有捕获到异常时,else 中的代码才会被执行

try:
    string = 'hello'
except:
    print('exception')
else:
    print('else')

# else
复制代码

我们还能在 try-except 后加上 finally,无论是否捕获到异常,finally 中的代码都会被执行

try:
    string = 'hello'
    number = int(string)
except:
    print('exception')
finally:
    print('finally')

# exception
# finally
复制代码

此外可以在 except 语句后指定异常类型,那么该 except 语句就只能捕获这种类型的异常

一个没有指定异常类型的 except 语句能捕获所有异常,但这样不能得到任何有效信息

try:
    li = list()
    li.add(123)
except AttributeError as e:
    print('AttributeError:', e)

# AttributeError: 'list' object has no attribute 'add'
复制代码

另外可以同时使用多个 except 语句处理不同的异常,但是要注意它们之间的顺序

因为当前面的 except 语句捕获到异常后,将不再执行后面的 except 语句

try:
    li = list()
    li[0] = 123
except IndexError as e:
    print('IndexError:', e)
except Exception as e:
    print('Exception:', e)

# IndexError: list assignment index out of range
复制代码

5、异常传播

当一个异常被抛出时,异常所在的作用域需要捕获并处理该异常

若异常在当前作用域没有得到处理,那么它将一直向上层作用域传递,直至它能够被处理

若异常一直向上传递到主程序都没有得到处理,那么程序将自动终止并显示错误信息

def faulty():
	raise Exception('Error')

def handle_exception():
    try:
        faulty()
    except:
        print('Exception Handled')

def ignore_exception():
	faulty()

handle_exception() # Exception Handled
ignore_exception() # 异常逐层传递直至主程序
# Traceback (most recent call last):
#   File "index.py", line 14, in <module>
#     ignore_exception() # Exception: Error
#   File "index.py", line 11, in ignore_exception
#     faulty()
#   File "index.py", line 2, in faulty
#     raise Exception('Error')
# Exception: Error
复制代码
文章分类
后端
文章标签